// This file was automatically generated. Do not edit this file!
#ifndef INITIALIZER_EXOTICA_CORE_CYLINDER_SHAPE_INITIALIZER_H
#define INITIALIZER_EXOTICA_CORE_CYLINDER_SHAPE_INITIALIZER_H

#include <exotica_core/property.h>

namespace exotica
{
inline std::vector<Initializer> GetExoticaCoreInitializers();
}

namespace exotica
{

class CylinderShapeInitializer : public InitializerBase
{
public:
    static std::string GetContainerName() { return "exotica/CylinderShape"; }

    CylinderShapeInitializer() : InitializerBase(),
        Type( "Cylinder") ,
        Color( Eigen::Vector4d::Zero()) 
    {
    }

    CylinderShapeInitializer( double _Radius, double _Length, std::string _Type =  "Cylinder", Eigen::Vector4d _Color =  Eigen::Vector4d::Zero()) : InitializerBase(),
        Radius(_Radius) ,
        Length(_Length) ,
        Type(_Type) ,
        Color(_Color) 
    {
    }

    CylinderShapeInitializer(const Initializer& other) : CylinderShapeInitializer()
    {
        if (other.HasProperty("Radius")) { const Property& prop = other.properties_.at("Radius"); if(prop.IsSet()) {Radius = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());} }
        if (other.HasProperty("Length")) { const Property& prop = other.properties_.at("Length"); if(prop.IsSet()) {Length = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());} }
        if (other.HasProperty("Type")) { const Property& prop = other.properties_.at("Type"); if(prop.IsSet()) {Type = boost::any_cast<std::string>(prop.Get());} }
        if (other.HasProperty("Color")) { const Property& prop = other.properties_.at("Color"); if(prop.IsSet()) {Color = prop.IsStringType()?ParseVector<double,4>(boost::any_cast<std::string>(prop.Get())):boost::any_cast<Eigen::Vector4d>(prop.Get());} }
    }

    virtual ~CylinderShapeInitializer()
    {
    }

    virtual Initializer GetTemplate() const
    {
        return (Initializer)CylinderShapeInitializer();
    }

    virtual std::vector<Initializer> GetAllTemplates() const
    {
        return GetExoticaCoreInitializers();
    }

    virtual void Check(const Initializer& other) const
    {
        if(!other.HasProperty("Radius") || !other.properties_.at("Radius").IsSet()) ThrowPretty("Initializer CylinderShapeInitializer requires property Radius to be set!");
        if(!other.HasProperty("Length") || !other.properties_.at("Length").IsSet()) ThrowPretty("Initializer CylinderShapeInitializer requires property Length to be set!");
    }

    operator Initializer()
    {
        Initializer ret(GetContainerName());
        ret.properties_.emplace("Radius", Property("Radius", true, boost::any(Radius)));
        ret.properties_.emplace("Length", Property("Length", true, boost::any(Length)));
        ret.properties_.emplace("Type", Property("Type", false, boost::any(Type)));
        ret.properties_.emplace("Color", Property("Color", false, boost::any(Color)));
        return ret;
    }

    double Radius;
    double Length;
    std::string Type;
    Eigen::Vector4d Color;
};

}

#include <exotica_core/exotica_core_initializers_numerator.h>


#endif